  /* CRHAIRS:                  ⮡ࠦ ४
			       Crosshairs.                   */
  #include <stdio.h>
  #include <graphics.h>
  #include <conio.h>

  #define N 40
  #define DX 15
  #define DY 6

  int Xmax, Ymax;

  int round(float x)
   /*  ⥫쭮 祭 x 㣫  襣 楫 */
   /*  The positive value x is rounded to the nearest integer    */
  { return ((int)(x + 0.5));
  }

  void cross(int X, int Y)
  { static int Xcur=-1, Ycur=-1;
    if (X < 0) X = 0; if (X > Xmax) X = Xmax;
    if (Y < 0) Y = 0; if (Y > Ymax) Y = Ymax;
    if (X != Xcur)
    { if (Xcur >= 0) line(Xcur, 0, Xcur, Ymax);
	    /*  ன  */     /* Remove old line */
      line(X, 0, X, Ymax);
	    /* 稢   */  /* Draw new line   */
    }
    if (Y != Ycur)
    { if (Ycur >= 0) line(0, Ycur, Xmax, Ycur);
	    /*  ன  */     /* Remove old line */
      line(0, Y, Xmax, Y);
	    /* 稢   */  /* Draw new line   */
    }
    Xcur = X; Ycur = Y;
  }

  main()
  { int gdriver=DETECT, gmode, i, OK, X, Y;
    char ch;
    float dX, dY;
    float redfact;
    /* 砫   ⨭,  䮭 ன
       㤥 ६ ४⨥  ࠧ襭 ⨭.
    */
    /* We first draw some picture, in which later
       crosshairs will move without destroying it.
    */
    printf /* "Reduction factor (not greater than 1): " */
	   (" 樥 㬥襭 (  1.) :  ");
    scanf("%f", &redfact);
    printf /* "When in graphics mode, you can move the crosshairs "
	   "by pressing anyof the four arrow keys. " */
	   ("\n ᪮ ० ४⨥  ६"
	     "  ࠭ \n⥬      "
	     "  ५.\n\n");
    printf /* "\nPressing any other key will "
	   "then cause the program to terminate.\n\n");
	   ("\n⨥  㣮  ਢ  襭"
	     " ࠡ ணࠬ.\n\n");
    printf /* "First, press any key to switch to the graphics mode ..." */
	   ("砫     室  ᪨"
	     " ० ...");
    getch();
    initgraph(&gdriver, &gmode, "\\tc");
    Xmax = round(getmaxx()*redfact);
    Ymax = round(getmaxy()*redfact);
    dX = (float)Xmax / N; dY = (float)Ymax / N;
    for (i=0; i<=N; i++)
    { line(0, round(i * dY), round(i * dX), Ymax);
      line(Xmax, Ymax - round(i * dY), Xmax - round(i * dX), 0);
    }
    /*                              ४⨥  業 ࠭:
		    Crosshairs through the center of the screen:
    */
    setwritemode(XOR_PUT);
    X = Xmax/2; Y = Ymax/2;
    cross(X, Y);
    /*                       ४⨥  ६:
				The crosshairs can now be moved:
    */
    OK = 1;
    while (OK && getch() == 0)
    { ch = getch();
      switch (ch)
      { case 72: cross(X, Y -= DY); break; /*   */ /* Up    */
	case 75: cross(X -= DX, Y); break; /*   */ /* Left  */
	case 77: cross(X += DX, Y); break; /* ࠢ */ /* Right */
	case 80: cross(X, Y += DY); break; /*    */ /* Down  */
	default: OK = 0;    /* ୠ  */  /* Wrong key */
      }
    }
    closegraph();
  }
