  /* DRAGON:                 ਢ ࠪ
			     Dragon curve
  */
  #include <stdio.h>
  #include "grasptc.h"
  int x=0, y=0, dx=4, dy=0, n, xmin=10, xmax=-10,
      ymin=10, ymax=-10, ixC, iyC;
  float fx, fy, f, xC, yC;

  float xreal(int x);
  float yreal(int y);
  void curve(int prescan);
  void step(int r, int prescan);

  main()
  { printf /* "How many line segments? (e.g. 256): " */
	("쪮 १ ? (ਬ, 256) :  ");
    scanf("%d", &n);
    curve(1);
    initgr();
    fx = x_max/(xmax - xmin); fy = y_max/(ymax - ymin);
    f = (fx < fy ? fx : fy) * 0.7;
    ixC = (xmin + xmax)/2;
    iyC = (ymin + ymax)/2;
    xC = x_max/2;
    yC = y_max/2;
    x = y = 0; dx=4; dy=0;
    move(xreal(x+dx/4), yreal(y));
    curve(0);
    endgr();
  }
  
  void curve(int prescan)
  { int i, j, r;
    for (i=1; i<=n; i++)
    { j=i;
      while ((j & 1) == 0) j >>= 1;
      r = j & 3;
      step(r, prescan);
    }
  }
  
  void step(int r, int prescan)
  { int t, dx1, dy1;
    if (prescan)
    { x += dx; y += dy;
      if (x < xmin) xmin = x;
      if (x > xmax) xmax = x;
      if (y < ymin) ymin = y;
      if (y > ymax) ymax = y;
    } else
    { dx1 = dx/4; dy1 = dy/4;
      draw(xreal(x + dx1), yreal(y + dy1));
      x += dx; y += dy;
      draw(xreal(x - dx1), yreal(y - dy1));
    }
    if (r == 1) {t = dx; dx = -dy; dy = t;} else
    /* r == 3 */ {t = dx; dx = dy; dy = -t;}
  
  }
  
  float xreal(int x)
  { return xC + f * (x - ixC);
  }
  
  float yreal(int y)
  { return yC + f * (y - iyC);
  }
