  /* INTTRIA:   ࠪ⠫  ᭮ אַ㣮 㣮쭨.
		 ࠡ .
		Fractals based on right triangles.
		Fast version.
  */
  #include <stdio.h>
  #include "grasptc.h"
  
  void tria(int xA, int yA, int xB, int yB, int xC, int yC, int n)
  { int xP, yP, xQ, yQ, xR, yR;
    if (n > 0)
    { xP = (xB + xC)/2; yP = (yB + yC)/2;
      xQ = (xC + xA)/2; yQ = (yC + yA)/2;
      xR = (xA + xB)/2; yR = (yA + yB)/2;
      moveto(xP, yP); lineto(xQ, yQ);
      lineto(xR, yR); lineto(xP, yP);
      tria(xA, yA,  xR, yR,  xQ, yQ,  n-1);
      tria(xB, yB,  xP, yP,  xR, yR,  n-1);
      tria(xC, yC,  xQ, yQ,  xP, yP,  n-1);
    }
  }

  main()
  { int n;
    int xA, yA, xB, yB, xC, yC;
    printf /* "Recursion depth (for example, 7): " */
	 ("\n㡨 ४ᨨ (ਬ, 7) :  "); scanf("%d", &n);
    initgr();
    xA = 0, yA = Y__max; xB = X__max; yB = Y__max; xC = 0; yC = 0;
    moveto(xA, yA); lineto(xB, yB); lineto(xC, yC); lineto(xA, yA);
    tria(xA, yA,  xB, yB,  xC, yC,  n);
    endgr();
  }
