  /* MENU:               祭 ⮥ .
			 A very simple menu.
  */
  #include <dos.h>
  #include <stdlib.h>
  #include <alloc.h>
  #include "grasptc.h"
  
  union REGS regs;
  
  int msinit(int Xlo, int Xhi, int Ylo, int Yhi);
  void msget(int *pX, int *pY, int *pbuttons);
  void msread(int *pX, int *pY, int *pbuttons);
  void mouse_cursor(int *pX, int *pY, int *pbut);
  void cursor(int X, int Y);
  void clearrectangle(int Xtop, int Ytop, int Xbottom, int Ybottom);
  void invertbox(int i, int X, int Y);
  void outtxtxy1(int X, int Y, char *str);

  char *ptr;

  #define WIDTH 100
  #define HEIGHT 30

  main()
  { int buttons, XC, YC, X, Y, i;
    initgr();
    XC = X__max/2; YC = Y__max/2;
    setlinestyle(SOLID_LINE, 0, THICK_WIDTH);
    settextstyle(SMALL_FONT, HORIZ_DIR, 0);
    setusercharsize(3, 2, 3, 2);
    settextjustify (CENTER_TEXT, CENTER_TEXT);
    ptr = farmalloc(imagesize(1, 1, WIDTH-1, HEIGHT-1));
    if (ptr == NULL)
    { outtextxy(XC, YC, /* "Not enough memory" */
		       " 墠⠥ " );
      delay(1000); exit(1);
    }
    if (msinit(0, X__max, 0, Y__max) == 0)
    { outtextxy(XC, YC, /* "Mouse or mouse driver absent" */
			" """"   ࠩ");
      delay(1000); exit(1);
    }
    rectangle(1, 1, X__max-1, Y__max-1);
    line(WIDTH, 0, WIDTH, 3*HEIGHT);
    for (i=1; i<=3; i++) line(0, i*HEIGHT+1, WIDTH, i*HEIGHT+1);
    outtxtxy1(WIDTH/3, HEIGHT/2,   "Item A");    /* "㪢 A" */
    outtxtxy1(WIDTH/2, 3*HEIGHT/2, "Item B");    /* "㪢 B" */
    outtxtxy1(WIDTH/2, 5*HEIGHT/2, "Quit");      /* "室"   */
    msread(&X, &Y, &buttons);
    setwritemode(XOR_PUT);
    cursor(X, Y);  /* ⮡ࠦ ᠬ ࢮ  */
                   /* Very first cursor                  */
    do
    { mouse_cursor(&X, &Y, &buttons);
      if (buttons && X < WIDTH && Y < 3*HEIGHT)
      { do mouse_cursor(&X, &Y, &buttons); while (buttons);
	  /*      !      */
          /* Now the button is no longer pressed down! */
        i = Y/HEIGHT;
	invertbox(i, X, Y);    /* 뤥 ࠭  */
			       /* Highlight selected item       */
        clearrectangle(XC-100, YC-20, XC+100, YC+20);
        switch (i)
	{ case 0: outtxtxy1(XC, YC, "Item A" ); /* "㪢 A" */
					 break;
	  case 1: outtxtxy1(XC, YC, "Item B" ); /* "㪢 B" */
					 break;
	  case 2: outtxtxy1(XC, YC, "Quit" );   /* "室"   */
                  delay(3000); to_text(); exit(0);
        }
        delay(2000);
        invertbox(i, X, Y);
      }
    } while (1);
  }

  void clearrectangle(int Xtop, int Ytop, int Xbottom, int Ybottom)
  { struct viewporttype vp;
    getviewsettings(&vp);
    setviewport(Xtop, Ytop, Xbottom, Ybottom, 0);
    clearviewport();
    setviewport(vp.left, vp.top, vp.right, vp.bottom, vp.clip);
  }

  void cursor(int X, int Y)
  { line(X-5, Y-3, X+5, Y-3);
    line(X-5, Y+3, X+5, Y+3);
    line(X-4, Y-1, X-4, Y+1);
    line(X+4, Y-1, X+4, Y+1);
  }
  
  void invertbox(int i, int x, int y)
  { int ih=i*HEIGHT;
    cursor(x, y);            /* ࠭ */         /* Erase */
    getimage(3, ih+3, WIDTH-2, ih+HEIGHT-1, ptr);
    putimage(3, ih+3, ptr, NOT_PUT);
    cursor(x, y);            /* ⠭ */   /* Restore */
  }



  void mouse_cursor(int *pX, int *pY, int *pbut)
  { int Xold=*pX, Yold=*pY;
    msread(pX, pY, pbut);
    cursor(Xold, Yold);   /* ࠭ ண  */
			  /* Erase old cursor */
    cursor(*pX, *pY);     /* 稢   */
			  /* Draw new cursor  */
  }

  int msinit(int Xlo, int Xhi, int Ylo, int Yhi)
  { int retcode;
    regs.x.ax = 0;
    int86(51, &regs, &regs);
    retcode = regs.x.ax;
      /* -1 = ⠭; 0 =  ⠭ */
      /* -1: installed; 0: not installed */
    if (retcode == 0) return 0;
    regs.x.ax = 7; regs.x.cx = Xlo; regs.x.dx = Xhi;
    int86(51, &regs, &regs);
    regs.x.ax = 8; regs.x.cx = Ylo; regs.x.dx = Yhi;
    int86(51, &regs, &regs);
    return retcode;
  }

  void msread(int *px, int *py, int *pbuttons)
  { static int x0=-10000, y0, but0;
    int xnew, ynew;
    do
    { regs.x.ax = 3;
      int86(51, &regs, &regs);
      xnew = regs.x.cx; ynew = regs.x.dx;
      *pbuttons = regs.x.bx;
    } while (xnew == x0 && ynew == y0 &&
             *pbuttons == but0);
    *px = x0 = xnew; *py = y0 = ynew;
    but0 = *pbuttons;
  }

  void outtxtxy1(int X, int Y, char *str)
  { setwritemode(COPY_PUT);
    outtextxy(X, Y, str);
    outtextxy(X+1, Y, str);
    outtextxy(X, Y+1, str);
    outtextxy(X+1, Y+1, str);
    setwritemode(XOR_PUT);
  }
