  /* MSDEMO2:   樮 ணࠬ 祭 १ 
		( ⢥ ⮢  ணࠬ SDRAW, . 5.6).
       A demonstration program for line drawing
       (intended as a preparation for program
       SDRAW, see Section 5.6.).
  */
  #include <conio.h>
  #include <dos.h>
  #include <stdio.h>
  #include <stdlib.h>
  #include <ctype.h>

  #include "grasptc.h"

  union REGS regs;

  int Xpixel(int x), Ypixel(int y), xhpg(int X), yhpg(int Y);
  int msinit(int Xlo, int Xhi, int Ylo, int Yhi);
  int msread(int *pX, int *pY, int *pbuttons);
  void getline(int *pxstart, int *pystart);
  void drline(int x1, int y1, int x2, int y2);
  void digitalline(char ch);
  void cursor(int X, int Y);
  void newposition(int *px, int *py, int *pX, int *pY, int *pbut);
  
  long x_max200, y_max200;
  int y200, xmin, xmax, ymin, ymax, Xmin, Xmax, Ymin, Ymax;

  #define txt(linenr, str) gotoxy(1, linenr); cprintf(str);

  main()
  { int buttons, xm, ym, X, Y, x, y;
    char str[100];
    clrscr();
    /* This program requires a mouse driver to be present.
       You can draw straight lines as follows:
       Move the cursor to one end point of the line, then press a mouse
       button, and move the cursor to the other end point of the line.
       Finally, release the mouse button.
       Normally, the cursor can only be placed at grid points that
       horizontally and vertically lie eight units apart. If you want
       the cursor to move very small distances, use the four arrow keys.
       Press the Home-key if and when you want the cursor to go back to
       a grid point. You can also draw a line by entering four numbers,
       namely the two coordinate pairs x1, y1, x2, y2 of its end points.
       Press any key on the keyboard to start the demonstration.         */

    txt(1, " ணࠬ ॡ  ࠩ """".");
    txt(4, "१    ᫥騬 ࠧ:");
    txt(5, "⠭   砫  १,  ");
    txt(6, "  """", ६    ");
    txt(7, "१   .");
    txt(9, "ଠ쭮   室 ⮫쪮  窠 ஢");
    txt(10, "⪨, ᯮ  ﭨ 쬨   ");
    txt(11, "㣠  ਧ⠫   ⨪.");
    txt(12, " 室  筮 ⠭   -");
    txt(13, "짮  蠬  ५.  ");
    txt(14, "  窠 ⪨ ᫥   ""Home"".");
    txt(16, "१ אַ    ⠪ ⥬  ");
    txt(17, "ᥫ x1, y1, x2, y2  -   न 楢 祪.");
    txt(19, "      砫 樨.");

    if (getch() == 3) exit(0); /* 3 = Ctrl-C */
    initgr();
    outtextxy(50, 50, /* "Move mouse, using any button." */
	      "६頩 """"  ⮩  .");
    outtextxy(50, 70, "(Q = 室)");   /* "Quit" */
    x_max200 = 200 * x_max; y_max200 = y200 = 200 * y_max;
    Xmin = 4; Xmax = X__max - 4;
    Ymin = 2; Ymax = Y__max - 12;
    xmax = xhpg(Xmax); ymax = yhpg(Ymin);
    xmin = xhpg(Xmin); ymin = yhpg(Ymax);
    outtextxy(50, 90, /* "Line input in digital form:" */
		      " १  ஢ ଥ: ");
    outtextxy(50, 110, "  x1  y1    x2  y2");
    sprintf(str, "x < %d   y < %d", xmax+1, ymax+1);
    outtextxy(50, 130, str);
    setwritemode(XOR_PUT);

    if (msinit(0, (int)x_max200, 0, (int)y_max200) == 0)
    { to_text();
      cprintf /* "No mouse or mouse driver" */
	      (" """"  ࠩ """" "); exit(1);
    }
    while (msread(&xm, &ym, &buttons) >= 0) ;
      /* 뢠 祭 xm  ym  ய   */
      /* Read xm and ym and skip any keyboard input. */
    x = xm; y = ym; cursor(x, y);

    for ( ; ; )                     /*  横 ணࠬ */
				    /* Main program loop      */
    { newposition(&x, &y, &X, &Y, &buttons);
      if (buttons) getline(&x, &y);
    }
  }

  /*             㭪樨  䠢⭮ 浪
		 Functions in alphabetic order:
  */

  void cursor(int x, int y)
  { int Xm4, Ym2, Ym1, Xp4, Yp2, Yp1, X, Y;
    X = Xpixel(x); Y = Ypixel(y);
    Xm4=X-4; Xp4=X+4; Ym2=Y-2; Ym1=Y-1; Yp1=Y+1; Yp2=Y+2;
    line(Xm4, Ym2, Xp4, Ym2); line(Xm4, Yp2, Xp4, Yp2);
    line(Xm4, Ym1, Xm4, Yp1); line(Xp4, Ym1, Xp4, Yp1);
  }

  void digitalline(char ch)
  { int x1, y1, x2, y2, i=0;
    char str[100];
    do
    { str[i++] = ch; ch = getch();
    } while (ch != '\n' && ch != '\r');
    str[i] = '\0';
    if (sscanf(str, "%d %d %d %d", &x1, &y1, &x2, &y2) < 4) return;
    drline(x1, y1, x2, y2);
  }

  void getline(int *pxstart, int *pystart)
  { int x, y, xstart, ystart, buttons, x0, y0, X, Y;
    x = xstart = *pxstart; X = Xpixel(x);
    y = ystart = *pystart; Y = Ypixel(y);
    do
    { x0 = x; y0 = y;
      newposition(&x, &y, &X, &Y, &buttons);
      if (x != x0 || y != y0)
      { drline(xstart, ystart, x0, y0);   /* ࠭ */  /* Erase */
	drline(xstart, ystart, x, y);     /* ७ */   /* Drag  */
      }
    } while (buttons);
    *pxstart=x; *pystart=y;
  }

  void drline(int x1, int y1, int x2, int y2)
  { int X1, Y1, X2, Y2;
    X1 = Xpixel(x1); Y1 = Ypixel(y1);
    X2 = Xpixel(x2); Y2 = Ypixel(y2);
    if (X1 == X2 && Y1 == Y2) return;
    line(X1, Y1, X2, Y2);
  }

  void endprogram(void)
  { to_text(); exit(0);
  }

  int msinit(int Xlo, int Xhi, int Ylo, int Yhi)
  { int retcode;
    regs.x.ax = 0; int86(51, &regs, &regs);
    retcode = regs.x.ax;
			/* -1 = ⠭; 0 =  ⠭ */
			/* -1: installed; 0: not installed      */
    if (retcode == 0) return 0;
    regs.x.ax = 7; regs.x.cx = Xlo; regs.x.dx = Xhi;
    int86(51, &regs, &regs);
    regs.x.ax = 8; regs.x.cx = Ylo; regs.x.dx = Yhi;
    int86(51, &regs, &regs);
    return retcode;
  }
  
  int msread(int *px, int *py, int *pbuttons)
  { static int x0=-10000, y0, but0;
    int xnew, ynew;
    do
    { if (kbhit()) return getch();
      regs.x.ax = 3; int86(51, &regs, &regs);
      xnew = regs.x.cx; ynew = regs.x.dx;
      *pbuttons = regs.x.bx;
    } while (xnew == x0 && ynew == y0 && *pbuttons == but0);
    *px = xnew; *py = y200 - ynew;
    x0 = xnew; y0 = ynew; but0 = *pbuttons;
    return -1;
  }
  
  void newposition(int *px, int *py, int *pX, int *pY, int *pbut)
  { int ch, x0=*px, y0=*py, x, y;
    static int xm, ym, xcorr=0, ycorr=0;
    ch = msread(&xm, &ym, pbut); ch = tolower(ch);
    if (ch >= 0)
    { if (ch == 0)
      { ch = getch();
        switch (ch)
	{ case 72: ycorr++; break; /*   */  /* Up     */
	  case 75: xcorr--; break; /*   */  /* Left   */
	  case 77: xcorr++; break; /* ࠢ */  /* Right  */
	  case 80: ycorr--; break; /*    */  /* Down   */
          case 71: xcorr = ycorr = 0; break; 
                                   /* Home   */
        }
      }
    }
    if (ch == 'q') endprogram(); else
    if (isdigit(ch)) digitalline(ch);
    x = xm + xcorr; y = ym + ycorr;
    if (x < xmin) x = xmin;
    if (x > xmax) x = xmax;
    if (y < ymin) y = ymin;
    if (y > ymax) y = ymax;
    if (x != x0 || y != y0)
    { cursor(x0, y0);    /* ࠭    */   /* Erase   */
      cursor(x, y);      /* ⮡ࠦ */   /* Display */
    }
    *px = x; *py = y;
    *pX = Xpixel(x); *pY = Ypixel(y);
  }
  
  int xhpg(int X)
  { return (int)(X * x_max200 / X__max);
  }
  
  int Xpixel(int x)
  { return (int)((long)X__max * x / x_max200);
  }
  
  int yhpg(int Y)
  { return (int)((Y__max - Y) * y_max200 / Y__max);
  }
  
  int Ypixel(int y)
  { return Y__max - (int)((long)Y__max * y / y_max200);
  }
