  /* SECTORS:
	    㣮  ᪨ ᥪ   䨪.
	    Pieslices and elliptic sectors for business diagrams.
  */
  #include "grasptc.h"

  main()
  { int XC, YC, XE, YE, R, H;
    initgr();
    XC = X__max/3; XE = 2*X__max/3, R = (XE - XC)/3; H = R/3;
    YC = YE = Y__max/2;

    setfillstyle(SOLID_FILL, foregrcolor);
    pieslice(XC, YC, 0, 10, R);      /* Sector 1 */  /*  1 */
    sector(XE, YE, 0, 10, R, H);

    setfillstyle(HATCH_FILL, foregrcolor);
    pieslice(XC, YC, 10, 60, R);     /* Sector 2 */  /*  2 */
    sector(XE, YE, 10, 60, R, H);

    setfillstyle(LTSLASH_FILL, foregrcolor);
    pieslice(XC, YC, 60, 190, R);    /* Sector 3 */  /*  3 */
    sector(XE, YE, 60, 190, R, H);

    setfillstyle(WIDE_DOT_FILL, foregrcolor);
    pieslice(XC, YC, 190, 360, R);   /* Sector 4 */  /*  4 */
    sector(XE, YE, 190, 360, R, H);

    endgr();
  }
