  /* SQFRACT:   稢 ࠪ⠫  ᭮ ⮢.
		This program draws a fractal based on squares.
  */
  #include <stdio.h>
  #include <stdlib.h>
  #include <math.h>
  #include "grasptc.h"

  float f, fact;

  void side(float xA, float yA, float xB, float yB,
           int n)
    { float xP, yP, xQ, yQ, xR, yR, xS, yS, fdx, fdy;
		     /*     窥 (xA, yA) */
		     /* Current pen position is (xA, yA)      */
    if (n == 0) draw(xB, yB); else
    { fdx = fact * (xB-xA); fdy = fact * (yB-yA);
      xP = xA + fdx; yP = yA + fdy;
      xS = xB - fdx; yS = yB - fdy;
      xQ = xP + (yS - yP); yQ = yP - (xS - xP);
      xR = xQ + (xS - xP); yR = yQ + (yS - yP);
      draw(xP, yP);
      side(xP, yP, xQ, yQ, n-1);
      side(xQ, yQ, xR, yR, n-1);
      side(xR, yR, xS, yS, n-1);
      draw(xB, yB);
    }
  }
    
  main()
  { int n, i;
    float p=1, r, R, xC, yC;
    printf /* "Recursion depth (for example: 5): " */
	 ("\n㡨 ४ᨨ (ਬ, 5) :  ");
    scanf("%d", &n);
    printf /* "Reduction factor (for example: 0.4): " */
	 ("\n樥 㬥襭 (ਬ, 0.4) :  ");
    scanf("%f", &f);
    for (i=0; i<n; i++) p *= f;
    fact = 0.5*(1-f);
    initgr();
    R = y_max/2.2 * (1-f)/(1-p); r = R/(1+f);
    xC = x_max/2; yC = y_max/2;
    move(xC-r, yC-r);
    side(xC-r, yC-r, xC+r, yC-r, n);
    side(xC+r, yC-r, xC+r, yC+r, n);
    side(xC+r, yC+r, xC-r, yC+r, n);
    side(xC-r, yC+r, xC-r, yC-r, n);
    endgr();
  }
