  /* SQUARES:    ணࠬ  ४ᨢ 㭪樥 祭 ⮢.
		 This program uses a recursive function to draw squares.
  */
  #define EAST 1
  #define NORTH 2
  #define WEST 3
  #define SOUTH 4

  #include <stdio.h>
  #include <stdlib.h>
  #include <math.h>
  #include "grasptc.h"

  float f, c;
  int filling, all4;

  void square1(float x, float y, float r)
  { float xA, yA, xB, yB, xC, yC, xD, yD;
    int points[10];
    xA = x-r; yA = y-r;
    xB = x+r; yB = y-r;
    xC = x+r; yC = y+r;
    xD = x-r; yD = y+r;
    if (filling)
    { points[0] = IX(xA); points[1] = IY(yA);
      points[2] = IX(xB); points[3] = IY(yB);
      points[4] = IX(xC); points[5] = IY(yC);
      points[6] = IX(xD); points[7] = IY(yD);
      points[8] = points[0]; points[9] = points[1];
      fillpoly(5, points);
    } else
    { move(xA, yA); draw(xB, yB);
      draw(xC, yC); draw(xD, yD); draw(xA, yA);
      /*  ਬ 㭪樨 'move'  'draw'  'drawpoly'
	  楫 祭 室 䠩 SQUARES.HPG.
	 Here we use 'move' and 'draw' rather than 'drawpoly',
         to produce the output file SQUARES.HPG.
      */
    }
  }

  void squares(float x, float y, float r, int n, int dir)
  { int n1=n-1;
    float fr=f*r, cr=c*r;
    if (n > 0)
    { if (dir != WEST || all4) squares(x+cr, y, fr, n1, EAST);
      if (dir != SOUTH || all4) squares(x, y+cr, fr, n1, NORTH);
      if (dir != EAST || all4) squares(x-cr, y, fr, n1, WEST);
      if (dir != NORTH || all4) squares(x, y-cr, fr, n1, SOUTH);
      square1(x, y, r);
    }
  }

  main()
  { int n, i, m;
    float p=1, r, R;
    printf /* "Recursion depth (for example: 5): " */
	 ("\n㡨 ४ᨨ (ਬ, 5) :  ");    scanf("%d", &n);
    printf /* "Reduction factor (for example: 0.5): " */
	 ("\n樥 㬥襭 (ਬ, 0.5) :  ");
    scanf("%f", &f);
     /* "For a square with sides at a distance r from its center P
	 its satellites squares will have centers at a distance cr
	 from point P. Enter c (for example: 2.0)"                    */
    printf("\n   ࠧࠬ ஭ 2r 業 ⥫"
	   " ⮢  \nᯮ  ﭨ cr  窨 P"
	   " - 業 室 .\n\n 祭 c "
	   "(ਬ, 2.0) :  ");      scanf("%f", &c);
    for (i=0; i<n; i++) p *= f;
	 /* "Type 1 if the squares are to be filled, and 0 otherwise: "*/
    printf ("\n ᫮ 1, ᫨    襭,"
	  "\n 0  ⨢ 砥 :  ");    scanf("%d", &filling);
    if (!filling) fplot = fopen("squares.hpg", "w");
    do
    { printf /* "Do you want 3 or 4 satellites per square? " */
	   ("\n 3  4 ⥫   ? ");
      scanf("%d", &m);
    } while (m < 3 || m > 4);
    all4 = (m == 4);
    initgr();
    setfillstyle(CLOSE_DOT_FILL, foregrcolor);
    R = y_max/2.2 * (1-f)/(1-p); r = R/c;
    squares(x_max/2, y_max/2, r, n, 0);
    endgr();
  }
