  /* TRANSFOR:        ८ࠧ
		    Recursion and transformations.
  */

  #include <stdio.h>
  #include "grasptc.h"

  float xreal(float x);
  float yreal(float y);
  void transf(float x, float y, int n, int prescan);
  float fx, fy, f, xC, yC, xmin0=100, xmax0=-100, ymin0=100,
        ymax0=-100, xC0, yC0, a, b, c, d, x0, x, y;
  int count=0, recdepth, level_5;

  main()
  { int i;
    printf /* "Recursion depth (e.g. 12): " */
	  ("\n㡨 ४ᨨ (ਬ, 12) :  ");
    scanf("%d", &recdepth); level_5 = recdepth - 5;
    printf /* "Enter a, b, c, d, x0 (e.g.  .7  .3  .5  .3  1): */
      ("\n ᫠ a, b, c, d, x0  "
				  "(ਬ,  .7  .3  .5  .3  1) :\n");
    printf("                                          ");
    scanf("%f %f %f %f %f", &a, &b, &c, &d, &x0);
    printf /* "Please wait; counter has final value 32: */
	 ("\n , 筮 祭 稪 㤥 32 :\n");
    transf(1.0, 0.0, recdepth, 1);
    initgr();
    fx = x_max/(xmax0 - xmin0);
    fy = y_max/(ymax0 - ymin0);
    f = (fx < fy ? fx : fy) * 0.8;
    xC0 = (xmin0 + xmax0)/2; yC0 = (ymin0 + ymax0)/2;
    xC = x_max/2; yC = y_max/2;
    count = 0;
    transf(1.0, 0.0, recdepth, 0);
    for (i=1; i<=32; i++) putpixel(8*i, 0, backgrcolor);
    endgr();
  }

  void transf(float x, float y, int n, int prescan)
  { float x1, y1;
    if (n > 0)
    { if (prescan)
      { if (n == level_5) printf("%d ", ++count);
        if (x < xmin0) xmin0 = x;
        if (x > xmax0) xmax0 = x;
        if (y < ymin0) ymin0 = y;
        if (y > ymax0) ymax0 = y;
      } else
      { if (n == level_5) putpixel(count+=8, 0, foregrcolor);
        putpixel(IX(xreal(x)), IY(yreal(y)), foregrcolor);
      }
      x1 = a * x + b * y;
      y1 = b * x - a * y;
	 /* ࠦ  ᦠ⨥ ⭮⥫쭮 䨪஢ 窨 (0, 0) */
	 /* Reflection and contraction; (0, 0) is fixed point          */
      transf(x1, y1, n-1, prescan);
      x1 = c * (x-x0) - d * y + x0;
      y1 = d * (x-x0) + c * y;
	 /*   ᦠ⨥ ⭮⥫쭮 䨪஢ 窨 (x0, 0) */
	 /* Rotation and contraction; (x0, 0) is fixed point          */
      transf(x1, y1, n-1, prescan);
    }
  }
  float xreal(float x)
  { return xC + f * (x - xC0);
  }

  float yreal(float y)
  { return yC + f * (y - yC0);
  }
