  /* TTREE:        ନ஢ ॢ  㪢 .
		   Letters T, forming a tree.
  */
  #include <stdio.h>
  #include <stdlib.h>
  #include <time.h>
  #include "grasptc.h"

  float fx, fy, threshold;

  void T(float xA, float yA, float a, float b, int n)
  { float xB, yB, xC, yC, xD, yD, a1, b1;

    /* A 砥   㪢 . 楢 窨 ਧ-
       ⠫쭮 (孥) १ 祭 㪢 C (᫥) 
       D (ࠢ), । 窠 - B.

       A is lower point of letter T; its (upper) horizontal line
       has end points C (left) and D (right), and midpoint B.
    */
    if (n > 0)
    { xB = xA; yB = yA + a;   /* AB = a      */
      xC = xB - b; yC = yB;   /* CB = BD = b */
      xD = xB + b; yD = yB;
      a1 = fy * a;
      if (a1 < 0) a1 = -a1;
      b1 = fx * b;
      move(xA, yA); draw(xB, yB); draw(xC, yC);
      T(xC, yC, (rand()%100 >= threshold ? -a1 : a1), b1, n-1);
      move(xB, yB); draw(xD, yD);
      T(xD, yD, (rand()%100 >= threshold ? -a1 : a1), b1, n-1);
    }
  }

  main()
  { float a, b, powerfx, powerfy;
    int n, i;
    long t;
    time(&t); srand((int)t);
    printf /* "Enter         fx,   fy,   recdepth  upwardpercentage */
       ("\n 祭 樥⮢:\n"
	"\n              fx    fy  㡨 ४ᨨ  % 㬥襭 "
	"\n\n(ਬ,    0.5   0.4          7           70)\n\n"  );
    printf("              ");
    scanf("%f %f %d %f", &fx, &fy, &n, &threshold);
    initgr();
    powerfx = fx; powerfy = fy;
    for (i=2; i<=n; i++)
    { powerfx *= fx; powerfy *= fy;
    }
    b = 0.5 * x_max * (1 - fx)/(1 - powerfx);
    a = y_max * (1 - fy)/(1 - powerfy);
    T(x_max/2, y_max/2 - a, a, b, n);
    endgr();
  }
