  /* CIRCLES:     ணࠬ ४ᨢ 稢 㦭⥩.
		  This program uses a recursive function to draw circles.
  */
  #include <stdio.h>
  #include <stdlib.h>
  #include <math.h>
  #include "grasptc.h"

  float f;
  int nsatellite, hpg;
  float ccos[100], csin[100];

  void scircle(float x, float y, float r)  /* 쪮  hpg = 1   */
					   /* Used only if hpg = 1 */
  { int n=(int)(30 * r + 8), i;
    float theta=2*PI/n;
    move(x+r, y);
    for (i=1; i<=n; i++) draw(x+r*cos(i*theta), y+r*sin(i*theta));
  }

  void circles(float x, float y, float r, int n)
  { int i, n1=n-1;
    float fr=f*r;
    if (n-- > 0)
    { if (hpg == 1) scircle(x, y, r); else circle_uc(x, y, r);
      for (i=0; i<nsatellite; i++)
      circles(x+r*ccos[i], y+r*csin[i], fr, n1);
    }
  }

  main()
  { int n, i;
    float p=1, r, R, c, theta;
    printf /* "Recursion depth (e.g. 4): " */
	 ("\n㡨 ४ᨨ (ਬ, 4) :  "); scanf("%d", &n);
    printf /* "Reduction factor (e.g. 0.3): " */
	 ("\n樥 㬥襭 (ਬ, 0.3) :  "); scanf("%f", &f);
	 /* "For a circle with radius r, the orbit of its satellites
	     will be a circle with radius cr. Enter c (e.g. 2.0):" */
    printf("\n 㦭  ࠤᮬ r ࡨ⮩  ⥫⮢ "
	    "㤥 \n㦭  ࠤᮬ cr.\n\n 祭"
	    " ࠬ c (ਬ, 2.0) :  "); scanf("%f", &c);
    for (i=0; i<n; i++) p *= f;
    printf /* "Number of satellite circles (for example: 8): " */
	 ("\n᫮ ⥫ 㦭⥩ (ਬ, 8) :  ");
    scanf("%d", &nsatellite);
    printf /* "Type 1 if you want an HP-GL file, and 0 otherwise: " */
	  ("\n 1, ᫨ 㦥 䠩 HP-GL,  0 "
	   " ⨢ 砥 :  ");  scanf("%d", &hpg);
    if (hpg == 1) fplot = fopen("circles.hpg", "w");
    if (nsatellite > 100) exit(1);
    theta = 2 * PI/nsatellite;
    for (i=0; i<nsatellite; i++)
    { ccos[i] = c * cos(i * theta);
      csin[i] = c * sin(i * theta);
    }
    initgr();
    R = 0.5 * y_max * (1-f)/(1-p); r = R/c;
    circles(x_max/2, y_max/2, r, n);
    endgr();
  }