  /* FRCURVE:     ணࠬ ந    ਧ-
	       ⠫쭮 १,   ஭ ࠢ쭮 -
	       㣮쭨 ࠪ⠫쭮 ਢ    ମ.
		 This program replaces either one horizontal line or
	       each side of a regular polygon with a fractal curve
	       of any given shape.
  */
  #include <stdio.h>
  #include <stdlib.h>
  #include <math.h>
  #include "grasptc.h"

  int nmodel = 0;
  float xx[30], yy[30];

  void side(float xA, float yA, float xB, float yB, 
            int n)
  { int i;
    float x, y, x1, y1, dx=xB-xA, dy=yB-yA;
    if (n == 0)
    { move(xA, yA); draw(xB, yB);
    } else
    { x1 = xA; y1 = yA;
      for (i=1; i<=nmodel; i++)
      { x = x1; y = y1;
        x1 = xA + dx * xx[i] - dy * yy[i];
        y1 = yA + dy * xx[i] + dx * yy[i];
        side(x, y, x1, y1, n-1);
      }
    }
  }
  
  main()
  { int n, k, i;
    float pi, theta, r, x, y, x1, y1, xC, yC,
          sizefactor, xmargin, phi;
    printf /* "Enter 1 if you want the base to be a horizontal line." */
     ("\n 1, ᫨ ⢥   ਧ⠫ १.");
    printf /* "For a regular polygon with k sides as base, enter k" */
     ("\n\n    ࠢ쭮 k-㣮쭨  ᫮ k\n");
    printf /* "(for example: 4): " */ ("(ਬ, 4) :  ");
    scanf("%d", &k);
    printf /* "Recursion depth (for example: 4): " */
      ("\n㡨 ४ᨨ (ਬ, 4) :  ");
    scanf("%d", &n);
    printf /* "How many model points between (0, 0) and (1, 0)" */
      ("\n쪮  祪  (0, 0)  (1, 0) ? ");
    printf /* "(for example: 3):" */ ("(ਬ, 3) :  ");
    scanf("%d", &nmodel);
    nmodel++;
    /* ࠬ nmodel । ⢮ १ אַ     */
    /*  楢묨 窠 (0, 0)  (1, 0)  १. */
    /* Now nmodel is the number of line segments                 */
    /* between (0, 0) and (1, 0).                                */

    printf /* "Enter the pairs (x, y) for your model points," */
	   /* "excluding (0, 0) and 1, 0), for example:       */
	("\n  न (x, y)  祪, ᪫"
	 " 窨 (0, 0)  (1, 0). \nਬ:  .45   0\n          "
	 " .5   .45\n           .55   0\n\n");

    for (i=1; i<nmodel; i++) scanf("%f %f", xx+i, yy+i);
    printf /* "Size factor (1.0 = normal size) :" */
	("\n樥 ࠧ (1.0 = ଠ ࠧ) :  ");
    scanf("%f", &sizefactor);
    xx[nmodel] = 1.0;
	   /* ⠫  ᨢ 樠 ﬨ */
	   /* Other array elements initialized to 0              */
    initgr();
    if (k < 3)
    { xmargin = 0.5*(x_max-sizefactor*(x_max-1));
      side(xmargin, 0.5 * y_max, x_max - xmargin, 0.5 * y_max, n);
    } else
    { xC = x_max/2; yC = y_max/2;
      r = 0.9 * yC * sizefactor;
      pi = 4 * atan(1.0);
      theta = 2 * pi / k; phi = -0.5 * theta;
      x1 = xC + r * cos(phi); y1 = yC + r * sin(phi);
      for (i=0; i<k; i++)
      { x = x1; y = y1;
        phi += theta;
        x1 = xC + r * cos(phi);
        y1 = yC + r * sin(phi);
        side(x, y, x1, y1, n);
      }
    }
    endgr();
  }