  /* GRASPTC0:  ᪠ ⥬  ணࠬ஢  ࡮ 
		(।⥫쭠 )
		Graphics System for Programming in Turbo C
		(Preliminary version)
  */
  #include <graphics.h>
  #include <conio.h>

  int X__max, Y__max, foregrcolor, backgrcolor, colorsum;
  float x_max=10.0, y_max=7.0, horfact, vertfact;
  
  void initgr(void)
  { int gdriver=DETECT, gmode;
    initgraph(&gdriver, &gmode, "\\tc");
    foregrcolor = getcolor(); backgrcolor = getbkcolor();
    colorsum = foregrcolor + backgrcolor;
    X__max = getmaxx(); Y__max = getmaxy();
    horfact = X__max/x_max; vertfact = Y__max/y_max;
  }
  
  int IX(float x)
  { return (int) (x * horfact + 0.5);
  }
  
  int IY(float y)
  { return (int) Y__max - (int)(y * vertfact + 0.5);
  }

  void move(float x, float y)

    /*  㭪樨 'moveto'  짮⥫᪨ न */
    /* User-coordinate version of 'moveto'                    */
  { moveto(IX(x), IY(y));
  }

  void draw(float x, float y)

    /*  㭪樨 'lineto'  짮⥫᪨ न */
    /* User-coordinate version of 'lineto'                    */
  { lineto(IX(x), IY(y));
  }

  void line_uc(float x1, float y1, float x2, float y2)

    /*  㭪樨 'line'   짮⥫᪨  न */
    /* User-coordinate version of 'line'                      */
  { line(IX(x1), IY(y1), IX(x2), IY(y2));
  }

  void endgr(void)
  { getch(); closegraph();
  }

  void invertpixel(int X, int Y)
  { putpixel(X, Y, colorsum - getpixel(X, Y));
  }
