  /* SPIRALS:                 㭮  ᯨࠫ
			      Pattern of spirals   */
  #include <math.h>
  #include "grasptc.h"
  
  int narc, nline;
  float rmax, n, halfpi, c, r0, delta;
  
  float radius(float phi)
  { return c * phi + r0;
  }
  
  spirals4(float x, float y)
  { int i, j, l;
    float phi0, phi, r, phi_offset;
    for (l=0; l<4; l++)
    { phi0 = l*halfpi;
      move(x+r0*cos(phi0), y+r0*sin(phi0));
      for (i=0; i<narc; i++)
      for (j=1; j<=nline; j++)
      { phi_offset = i * halfpi + j * delta;
        phi = phi0 + phi_offset;
        r = radius(phi_offset);
        draw(x+r*cos(phi), y+r*sin(phi));
      }
    }
  }

  main()
  { float x, y, rmax;
    halfpi = PI/2;
    printf /* "How many line segments on a spiral arc
				     of 90 degrees? (e.g. 12) */
	   ("쪮 १  㣥 ᯨࠫ 90 ࠤᮢ?"
	    "(ਬ, 12) :  ");
    scanf("%d", &nline);
    printf /* "How many spiral arc segments of 90 degrees on */
	   /* each spiral?  (e.g. 3) " */
	   ("쪮   90 ࠤᮢ   ᯨࠫ?"
	    " (ਬ, 3) :  ");
    scanf("%d", &narc);
    printf /* "Radius r is computed as follows: r = c * phi + r0 */
	   ("\n   㫥 : r = c * phi + r0\n");
    printf /* "(phi in radians, r and r0 in inches). */
	   ("( phi  ࠤ, r  r0  )\n");
    printf /* "Enter c and r0 (e.g. 0.15  0) */
	   (" 祭 c  r0 (ਬ, 0.15  0) :  ");
    scanf("%f %f", &c, &r0);
    delta = halfpi/nline; rmax = radius(narc * halfpi);
    initgr();
    for (x=0.2+rmax; x<=x_max-rmax-0.1999; x+=2*rmax)
    for (y=0.2+rmax; y<=y_max-rmax-0.1999; y+=2*rmax) spirals4(x, y);
    endgr();
  }  
